#!/bin/perl
#2008.12.9 Jinsung Park (jinsung@jmjs.com)

#==============================================================================#
package JARRAY;
#==============================================================================#
#------------------------------------------------------------------------------#
sub new {
#------------------------------------------------------------------------------#
	my ($class, @data) = @_;
	my $ref = [];
	bless $ref, $class;
	$ref->init(@data);
	return $ref;
}

#------------------------------------------------------------------------------#
sub init {
#------------------------------------------------------------------------------#
	my ($ref, @data) = @_;
	@$ref = @data;
}

#------------------------------------------------------------------------------#
sub add {
#------------------------------------------------------------------------------#
	my ($ref, @data) = @_;
	if(@data) { push(@$ref,@data);}
}

#------------------------------------------------------------------------------#
sub jprint {
#------------------------------------------------------------------------------#
	my ($ref,$tab,$hier) = @_;
	$hier ++;
	my $ctab = "";
	for(my $i=1;$i<$hier;$i++) { $ctab .= $tab;}
	my $oline = "$ref = (\n";
	for(my $i=0;$i<=$#$ref;$i++) {
		$alist = $$ref[$i];
		$oline .= "$ctab$tab\[$i\]=";
		if(ref($alist)) { $oline .= $alist->jprint($tab,$hier);	}
		else		{ $oline .= "$alist\n";			}
	}
	$oline .= "$ctab)\n";
	$oline;
}

#------------------------------------------------------------------------------#
sub list { my ($ref) = @_; return (@$ref); }
#------------------------------------------------------------------------------#

#------------------------------------------------------------------------------#
sub remove {
#------------------------------------------------------------------------------#
	my ($ref, @nums) = @_;
	my @data = @$ref;
	@$ref = ();
	foreach my $i (@nums) { $data[$i] = ();}
	for($i=0;$i<=$#data;$i++) { if($data[$i]) { $ref->add($data[$i]);} }
}

#------------------------------------------------------------------------------#
sub DESTROY { } #of JARRAY
#------------------------------------------------------------------------------#

#==============================================================================#
package JHASH;
#==============================================================================#
#------------------------------------------------------------------------------#
sub new {
#------------------------------------------------------------------------------#
	my ($class, @data) = @_;
	my $ref = {};
	bless $ref, $class;
	$ref->init(@data);
	return $ref;
}

#------------------------------------------------------------------------------#
sub init {
#------------------------------------------------------------------------------#
	my ($ref, @data) = @_;
	%$ref = (@data);
}

#------------------------------------------------------------------------------#
sub add {
#------------------------------------------------------------------------------#
	my ($ref, @data) = @_;
	if(@data) { %$ref = (%$ref,@data);}
}

#------------------------------------------------------------------------------#
sub jprint {
#------------------------------------------------------------------------------#
	my ($ref,$tab,$hier) = @_;
	$hier ++;
	my $ctab = "";
	for(my $i=1;$i<$hier;$i++) { $ctab .= $tab;}
	my $oline = "$ref = (\n";
	foreach $key (keys %$ref) {
		$oline .= "$ctab$tab\{$key\}=>";
		my $alist = %$ref->{$key};
		if(ref($alist))	{ $oline .= $alist->jprint($tab,$hier);	}
		else		{ $oline .= "$alist\n";			}
	}
	$oline .= "$ctab)\n";
	$oline;
}

#------------------------------------------------------------------------------#
sub remove {
#------------------------------------------------------------------------------#
	my ($ref, @keys) = @_;
	my @data = %$ref;
	%$ref = ();
	for($i=0;$i<$#data;$i+=2) {
		my $flag = 0;
		foreach $akey (@keys) { if($data[$i] eq $akey) { $flag = 1;} }
		if(! $flag) { $ref->add($data[$i],$data[$i +1]);}
	}
}

#------------------------------------------------------------------------------#
sub DESTROY { } #of JHASH
#------------------------------------------------------------------------------#

#==============================================================================#
package FFILE_L2W;
#==============================================================================#
@ISA = qw(JHASH);

#------------------------------------------------------------------------------#
sub init {
#------------------------------------------------------------------------------#
	my ($ref) = @_;
	
	%$ref = (	"comment"		, ""  ,
		 	"nword" 		, ""  ,
			"full_line_comment"	, ""  ,
			"line_comment"		, "//",
			"block_comment_begin"	, "/*",
			"block_comment_end"	, "*/",
			"cword", "\\\n\\\(\\\)\\\[\\\]\\\;\\\,\\\&\\\|\\\~"
		);
}

#------------------------------------------------------------------------------#
sub l2w {
#------------------------------------------------------------------------------#
	my ($ref, @lines) = @_;
	my @owords=();
	my $i; for($i=0;$i<=$#lines;$i++) {
		if(  ($$ref{'full_line_comment'} ne "")
		   &&($lines[$i] =~ /^$$ref{'full_line_comment'}/)
		   &&($lines[$i] =~ /\n$/) ) 
		{
				if($$ref{'nword'} ne "") {
					push(@owords,$$ref{'nword'});
					$$ref{'nword'} = "";
				}
				push(@owords,$lines[$i]);
		}
		else {
		my @as = split('',$lines[$i]);
		my $j; for($j=0;$j<=$#as;$j++) {
			if(ord($as[$j]) == 13) {
			}
			elsif($as[$j] eq "\\") {
				$$ref{'nword'} .= $as[$j];
				if($as[$j] =~ /[\s\n]+/) {
					while($as[$j +1] =~ /[\s\n]+/) { 
						$j ++;
						$$ref{'nword'} .= $as[$j];
					}
				}
				else {
					$j ++;
					$$ref{'nword'} .= $as[$j];
				}
			}
			elsif(($$ref{'comment'} eq '"')&&($as[$j] eq '"')) {
				push(@owords,$$ref{'nword'}.'"');
				$$ref{'comment'} = "";
				$$ref{'nword'} = "";
			}
			elsif(($$ref{'comment'} eq $$ref{'line_comment'})
			    &&($as[$j]          eq "\n"                 )) {
				push(@owords,$$ref{'nword'},"\n");
				$$ref{'comment'} = "";
				$$ref{'nword'} = "";
			}
			elsif(($$ref{'comment'} eq $$ref{'block_comment_begin'})
		&&(join('',@as[$j..($j+length($$ref{'block_comment_end'})-1)])
				        eq $$ref{'block_comment_end'}) ){
				push(@owords,
				     $$ref{'nword'}.$$ref{'block_comment_end'});
				$j+=length($$ref{'block_comment_end'})-1;
				$$ref{'nword'} = "";
				$$ref{'comment'} = "";
			}
			elsif($$ref{'comment'} ne "") {
				$$ref{'nword'} .= $as[$j];
			}
			elsif($as[$j] eq '"') {
				if($$ref{'nword'} ne "") {
					push(@owords,$$ref{'nword'});
				}
				$$ref{'nword'} = '"';
				$$ref{'comment'} = '"';
			}
			elsif(
		join('',@as[$j..($j+length($$ref{'line_comment'})-1)])
				        eq $$ref{'line_comment'} ){
				if($$ref{'nword'} ne "") {
					push(@owords,"$$ref{'nword'}");
				}
				$$ref{'nword'}  = $$ref{'line_comment'};
				$$ref{'comment'}= $$ref{'line_comment'};
				$j+=length($$ref{'line_comment'})-1;
			}
			elsif(
		join('',@as[$j..($j+length($$ref{'block_comment_begin'})-1)])
				        eq $$ref{'block_comment_begin'} ){
				if($$ref{'nword'} ne "") {
					push(@owords,$$ref{'nword'});
				}
				$$ref{'nword'}  = $$ref{'block_comment_begin'};
				$$ref{'comment'}= $$ref{'block_comment_begin'};
				$j+=length($$ref{'block_comment_begin'})-1;
			}
			elsif($as[$j]=~/[$$ref{'cword'}]/) {
				if($$ref{'nword'} ne "") {
					push(@owords,$$ref{'nword'});
					$$ref{'nword'}="";
				}
				push(@owords,$as[$j]);
			}
			elsif($as[$j] =~ /[\s]/) {
				if($$ref{'nword'} ne "") {
					push(@owords,$$ref{'nword'});
					$$ref{'nword'}="";
				}
				do {
					$$ref{'nword'}.=$as[$j];
					$j++;
				} while($as[$j] =~ /[\s]/); $j--;
				push(@owords,$$ref{'nword'});
				$$ref{'nword'}="";
			}
			else {
				$$ref{'nword'} .= $as[$j];
			}
		}
		}
	}
	@owords;
}

#==============================================================================#
package FFILE_W2C;
#==============================================================================#
@ISA = qw(JARRAY);

#------------------------------------------------------------------------------#
sub win {
#------------------------------------------------------------------------------#
	my ($ref,@data) = @_;
	return $ref->add(@data);
}

#------------------------------------------------------------------------------#
sub cout {
#------------------------------------------------------------------------------#
	my ($ref) = @_;
	my $fl=0;
	for(my $i=0; $i<=$#$ref;$i++) {
		if(   $$ref[$i]=~/^[ \t\\]/
		    ||$$ref[$i]=~/^\/\//
		    ||$$ref[$i]=~/^\/\*/) { }
	   	elsif($$ref[$i]=~/^\n/	) { if($fl) {$fl=3;}}
	   	elsif($$ref[$i]=~/^-/	) { if($fl) {$fl=2;}}
		else			  {	     $fl++; }

		if($fl>1) {
			$i += $fl-3;
			my @ol=@$ref[0..$i];
			@$ref=@$ref[$i+1..$#$ref];
			return @ol;
		}
	}
	return ();
}

#------------------------------------------------------------------------------#
sub rest {
#------------------------------------------------------------------------------#
	my ($ref,@data)=@_;
	@data=(@$ref,@data);
	@$ref=();
	return @data;
}

#==============================================================================#
package FFILE_LINE;
#==============================================================================#
@ISA = qw(JARRAY);

#------------------------------------------------------------------------------#
sub init {
#------------------------------------------------------------------------------#
	my ($ref,@data)=@_;
	if(@data) {
		push(@$ref,@data);
		my $class=$ref->class_check;
		if($class eq "FFILE_FLINE") { $ref->add_ffile;}
	}
}

#------------------------------------------------------------------------------#
sub cfilter {
#------------------------------------------------------------------------------#
	my ($ref)=@_;
	my @ods=();
	foreach $ad (@$ref) {
		if(  $ad=~/^[\s]/
		   ||$ad=~/^\/\//
		   ||$ad=~/^\/\*/) {}
		else { push(@ods,$ad);}
	}
	return @ods;
}

#------------------------------------------------------------------------------#
sub class_check {
#------------------------------------------------------------------------------#
	my ($ref)=@_;
	my $class="FFILE_LINE";
	my ($com0) = $ref->cfilter();
	if($com0=~/^-f/) { $class="FFILE_FLINE";}
	bless $ref, $class;
	return $class;
}

#==============================================================================#
package FFILE_FLINE;
#==============================================================================#
@ISA = qw(FFILE_LINE);

#------------------------------------------------------------------------------#
sub add_ffile {
#------------------------------------------------------------------------------#
	my ($ref)=@_;
	foreach $ad (@$ref) {
		if(  $ad=~/^[\s]/
		   ||$ad=~/^\/\//
		   ||$ad=~/^\/\*/
		   ||$ad=~/^-f/ ) {}
		elsif(-f $ad) { $ad = new FFILE $ad;}
	}
}

#==============================================================================#
package FFILE;
#==============================================================================#
@ISA = qw(JARRAY);

#------------------------------------------------------------------------------#
sub init {
#------------------------------------------------------------------------------#
	my ($ref,$fname) = @_;
	@$ref=($fname);
	return $ref->fread($fname);
}

#------------------------------------------------------------------------------#
sub fread {
#------------------------------------------------------------------------------#
	my ($ref,$fname) = @_;
	my $l2w = FFILE_L2W::new FFILE_L2W;
	my $w2c = new FFILE_W2C;
	open($fname,"$fname")||die("Can't open $fname.\n");
	while(my $aline=<$fname>) {
		$w2c->win($l2w->l2w($aline));
		while(my @data=$w2c->cout()) { $ref->add(new FFILE_LINE @data);}
	}
	if(my @data=$w2c->rest()) { $ref->add(new FFILE_LINE @data);}
	close($fname);
}

1;
