/******************************************************************************
 * JMJS Dual Port Ram Example						      *
 ******************************************************************************/
//=======================================
module jmjsramd (clka, clkb, addra, addrb, dina, dinb, douta, doutb, wea, web);
//=======================================
parameter	WIDTHA=1, DEPTHA=2, ADDR_WIDTHA=1,
		WIDTHB=1, DEPTHB=2, ADDR_WIDTHB=1, MULT=1;
//=======================================
input				clka, clkb, wea, web;
input	[ADDR_WIDTHA -1:0]	addra;
input	[ADDR_WIDTHB -1:0]	addrb;
input	[WIDTHA -1:0]		dina;
input	[WIDTHB -1:0]		dinb;
output	[WIDTHA -1:0]		douta;
output	[WIDTHB -1:0]		doutb;
//=======================================
reg	[ADDR_WIDTHA -1:0]	addra_r;
reg	[ADDR_WIDTHB -1:0]	addrb_r;
reg	[WIDTHA -1:0]		rcell	[0:DEPTHA -1];
reg	[WIDTHA -1:0]		dinbs	[0:MULT -1];
//=======================================
integer i;
//=======================================
always @(dinb) begin
	dinbs[0] = dinb[ 7: 0];
	dinbs[1] = dinb[15: 8];
	dinbs[2] = dinb[23:16];
	dinbs[3] = dinb[31:24];
end
//=======================================
always @(posedge clka) begin
	if(wea) rcell[addra] = dina;
	addra_r = addra;
end
//=======================================
always @(posedge clkb) begin
	if(web) begin
		for(i=0;i < MULT; i=i+1) begin
			rcell[addrb * MULT + i] = dinbs[i];
		end
	end
	addrb_r = addrb;
end
//=======================================
assign douta = rcell[addra_r];
//=======================================
assign doutb = {rcell[addrb_r * MULT + 3],
		rcell[addrb_r * MULT + 2],
		rcell[addrb_r * MULT + 1],
		rcell[addrb_r * MULT + 0]};
//=======================================
endmodule
//=======================================
